SystemOrganization addCategory: #Nautilus!

Object subclass: #Nautilus
	instanceVariableNames: 'selectedClass selectedPackage selectedCategory selectedMethod selectedGroup packages classes'
	classVariableNames: 'Groups RecentClasses'
	poolDictionaries: ''
	category: 'Nautilus'!

Nautilus class
	instanceVariableNames: 'maxSize'!

!Nautilus commentStamp: 'BenjaminVanRyseghem 3/17/2011 16:20' prior: 0!
Nautilus new open !

Nautilus class
	instanceVariableNames: 'maxSize'!

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 17:59'!
groups

	^ Groups ifNil: [Groups := GroupManager new]! !

!Nautilus class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/17/2011 14:13'!
maxSize

	^ maxSize ifNil: [ maxSize := 5]! !

!Nautilus class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/17/2011 14:13'!
maxSize: anInteger

	maxSize := anInteger.
	self recentClasses maxSize: anInteger.! !

!Nautilus class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/16/2011 10:00'!
packages: aCollection

	^ self new packages: aCollection! !

!Nautilus class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/17/2011 14:13'!
recentClasses

	^ RecentClasses ifNil: [ RecentClasses := HistoryCollection maxSize: self maxSize ]! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 10:00'!
allClasses

	^ self class environment allClassesAndTraits! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 10:00'!
allPackages

	^ RPackageOrganizer default packages sort: [:a :b | a name <= b name]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 10:02'!
classes
	
	^ classes ifNil: [ classes := self allClasses ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 10:01'!
classes: aCollection

	classes := aCollection! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 12:07'!
classesInTheSelectedPackage

	^ self selectedPackage
		ifNil: [{}]
		ifNotNil: [:package | 
			(package definedClasses asArray sort: [:a :b | a name <= b name]), (package extendedClasses asArray sort: [:a :b | a name <= b name])]! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 17:11'!
foundExtentionsIn: aClass

	| result |
	result :=  aClass extendingPackages.
	"self haltIf: [result isEmpty not]."
	^ result! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 14:04'!
groups
	
	^ self class groups! !

!Nautilus methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/7/2011 15:28'!
open

	(self uiClass on: self) open! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 10:00'!
packages

	^ packages ifNil: [self allPackages]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 10:02'!
packages: aCollection

	packages := aCollection.
	self classes: (aCollection gather: [:each | each classes ])! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 09:59'!
packagesUsedByTheSelectedClass

	| result class |
	result := OrderedCollection new.
	class := self selectedClass.
	
	class ifNil: [^{}].
	result add: class package.
	result addAll: (self foundExtentionsIn: class).
	result := result intersection: self packages.
	^ result select:[:each | each notNil]! !

!Nautilus methodsFor: 'accessing' stamp: 'StephaneDucasse 3/17/2011 15:25'!
recentClasses

	^ self class recentClasses! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 18:10'!
resetGroups

	Groups := nil! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedCategory

	^ selectedCategory! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedCategory: anObject

	selectedCategory := anObject! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedClass

	^ selectedClass! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 14:14'!
selectedClass: anObject

	selectedClass := anObject.
	anObject ifNotNil: [ self recentClasses add: anObject ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 13:55'!
selectedGroup

	^ selectedGroup! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 13:55'!
selectedGroup: anObject

	selectedGroup := anObject! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedMethod

	^ selectedMethod! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedMethod: anObject

	selectedMethod := anObject! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedPackage

	^ selectedPackage! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 14:09'!
selectedPackage: anObject

	selectedPackage := anObject! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:20'!
uiClass

	^ NautilusUI! !

Object subclass: #NautilusUI
	instanceVariableNames: 'model list list2 window methodsTree selectedMethod selectedCategory showCategories showHierarchy hierarchyClass cachedHierarchy showGroups showInstance showComment sourceTextArea showPackages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus'!

!NautilusUI class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:22'!
on: aNautilus

	^ self new model: aNautilus! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/15/2011 12:57'!
addAll: aWindow
			
			
	aWindow
		addMorph: (self buildFirstColumn: aWindow)
		frame: (0@0 corner: 0.33@0.5).		
				
	aWindow
		addMorph: (self buildSecondColumn: aWindow)
		frame: (0.33@0 corner: 0.66@0.5).

	aWindow 
		addMorph: (self buildMethodsTree)
		frame: (0.66@0 corner: 1@0.5).
	
	aWindow
		addMorph: (self buildCodePane)
		frame: (0@0.5 corner: 1@1)! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/16/2011 18:35'!
addClassInAGroup

	(DialogGroupAdder new
		groups:	self groups;
		elementToAdd: self selectedClass)
		open! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/17/2011 11:23'!
addPackageAsGroup

	| package |
	package := self selectedPackage.
	^ self groups	
			addAGroupSilentlyNamed: package name 
			with: package classes! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/17/2011 11:24'!
addPackageAsGroupAndBrowse

	self addPackageAsGroup
		ifTrue: [
			self selectedGroup: self selectedPackage name.
			self showGroups: true]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/14/2011 18:13'!
addSubclassesOf: aClass in: result withIndex: index

	(aClass subclasses sort: [:a :b| a name <= b name]) do: [:each |
		result add: each -> index.
		self addSubclassesOf: each in: result withIndex: index + 1]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 14:25'!
addSubclassesOf: aClass in: result withIndex: index fromRestrictedCollection: aCollection

	| classes |
	
	classes := aClass subclasses intersection: aCollection.
	(classes sort: [:a :b| a name <= b name]) do: [:each |
		result add: each -> index.
		self addSubclassesOf: each in: result withIndex: index + 1 fromRestrictedCollection: aCollection]! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/7/2011 17:34'!
arrowKey: aCharacter from: aPluggableListMorph 
	aCharacter == $b
		ifTrue: [
			self selectedClass ifNotNil: [:class | class browse]]! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/15/2011 11:47'!
buildCodePane

	sourceTextArea := PluggableTextMorph
				on: self
				text: #sourceCode
				accept: #compileSource: 
				readSelection: nil
				menu: #msgPaneMenu:shifted:.
				
	^ sourceTextArea! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/15/2011 11:40'!
buildCommentButton

	^ (PluggableButtonMorph
			on: self 
			getState: #commentButtonState
			action: #commentButtonAction
			label: #commentButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/16/2011 12:21'!
buildFirstColumn: aWindow

	^ (aWindow newColumn: {
		self buildLabelMorph.
		self buildList.
		aWindow newRow: {self buildToogleButton. self buildGroupsButton}}) 
		hResizing: #spaceFill; vResizing: #spaceFill! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 14:35'!
buildGroupHierarchyFor: aGroup

	| result tmp index |
	result := OrderedCollection new.
	aGroup ifNil: [^ result ].
	((self rootsOfGroup: aGroup) asArray sort: [:a :b | a name <= b name ]) do:[:class |
		result add: (class -> 0).
		self addSubclassesOf: class in: result withIndex: 1 fromRestrictedCollection: (self groups at: aGroup)].
	^ result! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/14/2011 19:04'!
buildGroupsButton

	^ (PluggableButtonMorph
			on: self 
			getState: #groupsButtonState
			action: #groupsButtonAction
			label: #groupsButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 13:37'!
buildHierarchyFor: aClass

	| result tmp index |
	
	aClass ifNil: [^ {}].
	result := OrderedCollection new.
	tmp := aClass withAllSuperclasses reverse.
	1 to: tmp size do: [:i | result add: (tmp at: i) -> (i-1)].

	index := (tmp size -1).
	self addSubclassesOf: aClass in: result withIndex: index + 1.
	^ result! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/14/2011 19:27'!
buildInstanceButton

	^ (PluggableButtonMorph
			on: self 
			getState: #instanceButtonState
			action: #instanceButtonAction
			label: #instanceButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/8/2011 16:09'!
buildLabelMorph

	^ LabelMorph new 
		model: self; 
		getTextSelector: #labelText! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/8/2011 16:59'!
buildLabelMorph2

	^ LabelMorph new 
		model: self; 
		getTextSelector: #labelText2! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/16/2011 17:33'!
buildList

	list := PluggableListMorph
				on: self
				list: #getList
				selected: #selected
				changeSelected: #selected:
				menu: #menu:shifted:.
	list doubleClickSelector: #doubleClick.
	list wrapSelector: #listWrapper:.
	list hResizing: #spaceFill.
	list vResizing: #spaceFill.
	^ list! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/16/2011 18:38'!
buildList2

	list2 := PluggableListMorph
				on: self
				list: #getList2
				selected: #selected2
				changeSelected: #selected2:
				menu: #menu2:shifted:.
	list2 wrapSelector: #listWrapper2:.
	list2 hResizing: #spaceFill.
	list2 vResizing: #spaceFill.
	^ list2! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 13:06'!
buildMethodsTree

	methodsTree := SwitchableCategoriesTreeWithLabel
							on: self
							rootsSelector: #roots
							categoriesLabelSelector: #categoriesLabel
							elementsLabelSelector: #methodsLabel
							categoriesButtonLabelSelector: #categoriesButtonLabel
							elementsButtonLabelSelector: #methodsButtonLabel
							getSwitchSelector: #getSwitch
							setSwitchSelector: #setSwitch:
							getSelectedElementSelector: #selectedMethod
							setSelectedElementSelector: #selectedMethod:
							getSelectedCategorySelector: #selectedCategory
							setSelectedCategorySelector: #selectedCategory:
							setCategoryWrapperSelector: #categoryWrapper:
							setElementWrapperSelector: #methodWrapper:.

	^ methodsTree build! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 14:24'!
buildPackageHierarchyFor: aPackage

	| result tmp index |
	result := OrderedCollection new.
	((self rootsOf: aPackage) asArray sort: [:a :b | a name <= b name ] )do:[:class |
		result add: (class -> 0).
		self addSubclassesOf: class in: result withIndex: 1 fromRestrictedCollection: aPackage definedClasses].
	(aPackage extendedClasses  asArray sort: [:a :b | a name <= b name ] )do:[:class |
		result add: (class -> 0)].
	^ result! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/15/2011 12:56'!
buildPackagesClassesColumn: aWindow


	"container := PanelMorph new."
	"to fix in order to avoid the resize"
	
	"^ aWindow newColumn: {
			(aWindow newRow: {
				self buildFirstColumn: aWindow.
				self buildSecondColumn: aWindow})
				hResizing: #spaceFill; vResizing: #spaceFill.
			self buildToogleButton}"! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/15/2011 12:06'!
buildRootsFromClass: aClass

	| result |
	result := Dictionary new.
	aClass ifNil: [^result].
	
	aClass methodDict values do: [:method || category |
		category := method category.
		(result at: category ifAbsent: [result at: category put: (SortedCollection sortBlock: [:a :b | a selector <= b selector])]).
		(result at: category) add: method].
	^ result! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/15/2011 12:06'!
buildRootsFromClassSide: aClass

	| result |
	result := Dictionary new.
	aClass ifNil: [^result].
	
	aClass class methodDict values do: [:method || category |
		category := method category.
		(result at: category ifAbsent: [result at: category put: (SortedCollection sortBlock: [:a :b | a selector <= b selector])]).
		(result at: category) add: method].
	^ result! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/15/2011 12:14'!
buildSecondColumn: aWindow

	^ (aWindow newColumn: {
		self buildLabelMorph2.
		self buildList2.
		aWindow newRow: {self buildInstanceButton. self buildCommentButton}}) 
		hResizing: #spaceFill; vResizing: #spaceFill! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 16:47'!
buildTabbedNameOf: anElement
			
	| tab result assoc |
	
	tab := '   '.
	result := ''.
	assoc := cachedHierarchy detect: [:each | each key == anElement ] ifNone: [''->0].
	1 to: assoc value do: [:i | result := tab, result].
	^ self selectedPackage 
		ifNil: [result, anElement name]
		ifNotNil: [:package | 
			(package extendedClasses includes: anElement)
				ifTrue: [ result , '*', anElement name ]
				ifFalse: [ result, anElement name ]]! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/8/2011 17:26'!
buildToogleButton

	^ (PluggableButtonMorph
			on: self 
			getState: #toogleButtonState
			action: #toogleButtonAction
			label: #toogleButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/14/2011 12:58'!
categoriesButtonLabel

	^ 'Switch to methods'! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/14/2011 19:36'!
categoriesLabel

	^ self showInstance
		ifTrue: ['Categories:']
		ifFalse: ['Class categories:']! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/14/2011 17:15'!
categoryWrapper: anItem

	^ anItem! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/8/2011 17:01'!
changedLabels

	self changed: #labelText.
	self changed: #labelText2.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/15/2011 12:59'!
classLabel

	^'Class'! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/17/2011 12:37'!
classesMenu: aMenu shifted: b
		
	self selectedClass notNil 
		ifTrue: [
			self showGroups
				ifTrue: [
					aMenu
						add: 'Remove from Group (x)' translated
						target: self
						selector: #removeClassFromGroup
					]
				ifFalse: [
					aMenu
						add: 'Add in Group (e)' translated
						target: self
						selector: #addClassInAGroup]]! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/15/2011 11:41'!
commentButtonAction

	self toogleShowComment! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/15/2011 11:41'!
commentButtonLabel

	^ self commentLabel! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/15/2011 11:41'!
commentButtonState

	^ self showComment! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/15/2011 12:58'!
commentLabel

	^ 'Show Comments'! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/16/2011 18:58'!
defaultClassDescriptor

	| string |
	string := 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: '''.
	^ self selectedPackage
		ifNil: [string, '''' ]
		ifNotNil: [:package | string, package name, '''' ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/14/2011 15:16'!
doubleClick

	self ifPackages: [ self doubleClickOnPackage ] ifClasses: [ self doubleClickOnClass ]! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/14/2011 15:25'!
doubleClickOnClass

	self toogleShowHierarchy! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/14/2011 15:16'!
doubleClickOnPackage

	(self model class packages: {self selectedPackage}) open! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 14:12'!
foundPackageOf: aClass

	aClass ifNil: [^ nil].
	^ aClass package! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 13:23'!
getClassHierarchy

	self hierarchyClass
		ifNil: [^self getClassesList].

	^ cachedHierarchy collect: [:each | each key ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 13:34'!
getClassHierarchy2

	self showPackages ifFalse: [self halt].
	^ self selectedPackage
		ifNil: [{}]
		ifNotNil:[:package |
			cachedHierarchy := self buildPackageHierarchyFor: package.
			cachedHierarchy collect: [:each | each key ]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 10:02'!
getClassesList

	^ self model classes! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 12:11'!
getClassesList2

	^ self model packagesUsedByTheSelectedClass! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 16:35'!
getGroupHierarchy

	^ self selectedGroup 
		ifNil: [^ {}]
		ifNotNil: [:group |
			cachedHierarchy := self buildGroupHierarchyFor: group.
			cachedHierarchy collect: [:assoc | assoc key] ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 18:12'!
getGroupsKeyList

	^ self groups groupsNames! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 14:05'!
getGroupsValuesList

	^ self groups at: self selectedGroup ifAbsent: [{}]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 12:44'!
getList
	
	^
	self 
		ifGroups: [ self getGroupsKeyList ]
		ifNot: [
			self 
				ifPackages: [ self getPackagesList ] 
				ifClasses: [
					self selectedClass
						ifNil: [ 
							cachedHierarchy
								ifNil: [ self getClassesList ]
								ifNotNil: [:col | col collect: [:assoc | assoc key]]]
						ifNotNil: [:class | 
							self showHierarchy
								ifTrue: [ self getClassHierarchy ]
								ifFalse:[ {class} ]]]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 18:32'!
getList2
	
	^ self 
		ifGroups: [
			self showHierarchy
				ifTrue: [ self getGroupHierarchy ]
				ifFalse: [ self getGroupsValuesList ]]
		ifNot: [
			 self 
				ifPackages: [
					self showHierarchy
						ifTrue: [ self getClassHierarchy2 ]
						ifFalse: [ self getPackagesList2 ]]
				ifClasses: [self getClassesList2 ]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 09:59'!
getPackagesList

	^ self model packages! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 12:18'!
getPackagesList2

	^ self model classesInTheSelectedPackage! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/14/2011 13:00'!
getSwitch 

	^ showCategories ifNil: [showCategories := true]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 14:04'!
groups

	^ self model groups! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/14/2011 19:07'!
groupsButtonAction

	self toogleShowGroups! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/14/2011 19:05'!
groupsButtonLabel

	^ self groupsLabel! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/14/2011 19:05'!
groupsButtonState

	^ self showGroups! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/14/2011 19:05'!
groupsLabel

	^ 'Show Groups'! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/16/2011 18:17'!
groupsMenu: aMenu shifted: b
		
	aMenu
		add: 'Rename (r)' translated
		target: self
		selector: #renameAGroup.
		
	aMenu
		add: 'Remove (x)' translated
		target: self
		selector: #removeAGroup.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/14/2011 18:52'!
hideHierarchyLabel

	^ 'Hierarchy'! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/14/2011 16:30'!
hierarchyClass

	^ hierarchyClass! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 12:16'!
hierarchyClass: aClass

	hierarchyClass := aClass.
	cachedHierarchy := self buildHierarchyFor: aClass.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 13:54'!
ifGroups: aBlock ifNot: anotherBlock

	^self showGroups
			ifTrue: aBlock
			ifFalse: anotherBlock! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/7/2011 15:20'!
ifPackages: pBlock ifClasses: cBlock

	^ self showPackages
		ifTrue: pBlock
		ifFalse: cBlock! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 13:49'!
initialize

	super initialize.
	cachedHierarchy := OrderedCollection new.! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/14/2011 19:28'!
instanceButtonAction

	self toogleShowInstance! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/14/2011 19:28'!
instanceButtonLabel

	^ self showInstance
		ifTrue: [ self instanceLabel ]
		ifFalse: [ self classLabel ]! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/15/2011 12:05'!
instanceButtonState

	^ self showInstance not! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/15/2011 12:59'!
instanceLabel

	^'Instance'! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/8/2011 16:57'!
labelText

	^ self ifPackages: ['Packages:'] ifClasses: ['Classes:']! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/8/2011 16:59'!
labelText2

	^ self ifPackages: ['Classes:'] ifClasses: ['Packages:']! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:59'!
list

	^ list! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 16:12'!
list2

	^ list2! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 16:12'!
list2: anObject

	list2 := anObject! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:59'!
list: anObject

	list := anObject! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 16:48'!
listWrapper2: anElement

	^ self 
		ifPackages:	[
			"anElement is a Class"
			self showHierarchy
				ifTrue: [ self buildTabbedNameOf: anElement ]
				ifFalse: [
					(self selectedPackage extendedClasses includes: anElement)
						ifTrue: ['*', anElement name]
						ifFalse: [anElement name]]]
		ifClasses: [
			"anElement is a RPackage"
			(self selectedClass package == anElement)
				ifTrue: [anElement name]
				ifFalse: ['*', anElement name]]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/16/2011 14:16'!
listWrapper: anElement

	anElement = 0 ifTrue: [^''].
	^ self 
		ifGroups: [ anElement ]
		ifNot: [ self 
				ifPackages: [ anElement name  ] 
				ifClasses: [ 
					self showHierarchy
						ifTrue: [ self buildTabbedNameOf: anElement ]
						ifFalse:[ anElement name ]]]! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/17/2011 12:37'!
menu2: aMenu shifted: b 

	self 
		ifPackages: [ self classesMenu: aMenu shifted: b ]
		ifClasses: [ 
			self showGroups
				ifTrue: [ self groupsMenu: aMenu shifted: b ]
				ifFalse: [ self packagesMenu: aMenu shifted: b ]].
	^ aMenu! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/16/2011 18:20'!
menu: aMenu shifted: b 

	self 
		ifPackages: [ 
			self showGroups
				ifTrue: [ self groupsMenu: aMenu shifted: b ]
				ifFalse: [ self packagesMenu: aMenu shifted: b ]]
		ifClasses: [ self classesMenu: aMenu shifted: b ].
	^ aMenu! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/14/2011 19:19'!
methodWrapper: anItem

	^ anItem selector! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/14/2011 13:00'!
methodsButtonLabel

	^ 'Switch to categories'! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/14/2011 19:21'!
methodsLabel

	^ self showInstance
		ifTrue: ['Methods']
		ifFalse: ['Class methods']! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:59'!
model

	^ model! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:59'!
model: anObject

	model := anObject! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 16:21'!
open

	window := StandardWindow new.
	self addAll: window.
	window openInWorld.
	window title: self title! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/17/2011 11:28'!
packagesMenu: aMenu shifted: b

	aMenu
		add: 'Find Class... (f)'
		target: self
		selector: #openFindAClass.
		
	aMenu addLine.	
	aMenu
		add: 'Add as Group & Browse (g)' translated
		target: self
		selector: #addPackageAsGroupAndBrowse.
		
	aMenu
		add: 'Add as Group (G)' translated
		target: self
		selector: #addPackageAsGroup.! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/16/2011 18:32'!
removeAGroup

	self groups removeAGroup: self selectedGroup.
	self selectedGroup: nil.
	self changed: #getList.
	self changed: #getList2! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/16/2011 18:42'!
removeClassFromGroup

	self groups remove: self selectedClass from: self selectedGroup.
	self changed: #getList2.! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/16/2011 18:27'!
renameAGroup

	| newName |
	newName := self groups renameAGroup: self selectedGroup.
	self selectedGroup: newName.
	self changed: #getList.
	self changed: #getLIst2! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/15/2011 12:07'!
roots

	^ self showInstance
		ifTrue: [ self buildRootsFromClass: self selectedClass]
		ifFalse: [ self buildRootsFromClassSide: self selectedClass ].! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 12:04'!
rootsOf: aPackage

	^ aPackage definedClasses select: [:each |
		(aPackage definedClasses includes: each superclass)  not]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 14:27'!
rootsOfGroup: aGroup

	| classes |
	classes := self groups at: aGroup.
	^ classes select: [:each |
		(classes includes: each superclass)  not]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 16:59'!
selected

	| item |
	item :=  self 
				ifGroups: [ self selectedGroup ]
				ifNot: [ self ifPackages: [ self selectedPackage ] ifClasses: [ self selectedClass ]].
				
	^self getList indexOf: item.
	"^ selected ifNil: [selected := 0]"! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 11:13'!
selected2

	| item |
	item :=  self ifPackages: [ self selectedClass ] ifClasses: [ self selectedPackage ].
	^self getList2 indexOf: item.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 13:19'!
selected2: anInteger

	| selection |
	selection := self getList2 at: anInteger ifAbsent: [nil].
	self 
		ifPackages: [ self selectedClass: selection ] 
		ifClasses: [ self selectedPackage: selection ].
	self changed: #selected2.
	anInteger = 0 ifTrue: [^self].
	self changed: #getList.
	self changed: #getList2.
	self changed: #selected.
	! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 17:01'!
selected: anInteger

	| selection |
	selection := self getList at: anInteger ifAbsent: [nil].
	self 
		ifGroups: [ self selectedGroup: selection ]
		ifNot: [ self ifPackages: [ self selectedPackage: selection] ifClasses: [ self selectedClass: selection] ].

	self changed: #selected.
	self changed: #getList2! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/14/2011 12:59'!
selectedCategory

	^ selectedCategory! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/14/2011 12:59'!
selectedCategory: anObject

	selectedCategory := anObject! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 15:30'!
selectedClass

	^ self model selectedClass! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 12:44'!
selectedClass: aClass 

	self model selectedClass: aClass.
	self showGroups ifTrue: [self selectedPackage: (self foundPackageOf: aClass) ].
	self showPackages
		ifFalse: [ 
			self selectedPackage: (self foundPackageOf: aClass).
			self changed: #getList2].
	self selectedMethod: nil.
	self update.
	self changed: #sourceCode! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/15/2011 12:43'!
selectedClassComments

	^ self selectedClass comment! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/15/2011 11:55'!
selectedClassDescription

	^ self selectedClass definition! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 14:02'!
selectedGroup
	
	^ self model selectedGroup! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 14:01'!
selectedGroup: anObject

	self model selectedGroup: anObject! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/8/2011 11:57'!
selectedMethod
	^ selectedMethod! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/15/2011 12:49'!
selectedMethod: aCompiledMethod 

	selectedMethod := aCompiledMethod.
	self changed: #sourceCode! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/15/2011 11:58'!
selectedMethodComments

	^ self selectedMethod comment! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/15/2011 11:59'!
selectedMethodSource

	^ self selectedMethod getSource! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 15:30'!
selectedPackage

	^ self model selectedPackage! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 14:11'!
selectedPackage: aPackage

	self model selectedPackage: aPackage.
	(self showPackages and: [self selectedClass notNil and: [self selectedClass package ~= aPackage]])
		ifTrue: [ self selectedClass: nil ].
	self changed: #sourceCode! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/14/2011 13:01'!
setSwitch: aBoolean

	showCategories := aBoolean! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/15/2011 11:42'!
showComment

	^ showComment ifNil: [showComment := false.]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/15/2011 12:44'!
showComment: aBoolean

	showComment := aBoolean.
	self changed: #sourceCode! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/14/2011 19:06'!
showGroups

	^ showGroups ifNil: [ showGroups := false].! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 16:32'!
showGroups: aBoolean

	showGroups := aBoolean.
	self changed: #getList.
	self changed: #getList2.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 12:16'!
showHierarchy

	^ showHierarchy ifNil: [showHierarchy := true]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 17:26'!
showHierarchy: aBoolean

	showHierarchy := aBoolean.
	aBoolean 
		ifTrue: [self hierarchyClass: self selectedClass]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/14/2011 18:52'!
showHierarchyLabel

	^ 'Hierarchy'! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/14/2011 19:18'!
showInstance

	^ showInstance ifNil: [ showInstance := true ].! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/14/2011 19:37'!
showInstance: aBoolean

	showInstance := aBoolean.
	self selectedMethod: nil.
	methodsTree update.
	self changed: #instanceButtonLabel! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 13:16'!
showPackages

	^ showPackages ifNil: [showPackages := true]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 17:26'!
showPackages: aBoolean

	showPackages := aBoolean.
	aBoolean ifFalse: [
		self hierarchyClass: self selectedClass].
	self showGroups
		ifTrue: [self showGroups: false].
	self changed: #getList.
	self changed: #getList2.
	self changed: #toogleButtonLabel.
	self changedLabels.! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/16/2011 13:55'!
sourceCode

	^self selectedClass isNil
		ifTrue: [self defaultClassDescriptor]
		ifFalse:[
			self selectedMethod isNil
				ifTrue: [
					self showComment
						ifTrue: [self selectedClassComments]
						ifFalse: [self selectedClassDescription]]
				ifFalse: [
					self showComment
						ifTrue: [self selectedMethodComments]
						ifFalse: [self selectedMethodSource]]].
		! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:21'!
title

	^'Nautilus'! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/7/2011 15:14'!
toogleButtonAction

	self toogleShowPackages! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/16/2011 13:39'!
toogleButtonLabel

	^ 'Hierarchy'! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/14/2011 18:52'!
toogleButtonState

	^ false! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/14/2011 19:27'!
toogleShowComment

	self showComment: self showComment not! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/14/2011 19:07'!
toogleShowGroups

	self showGroups: self showGroups not.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 12:09'!
toogleShowHierarchy

	self showHierarchy: self showHierarchy not.
	self changed: #getList.
	self changed: #getList2.
! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/14/2011 19:19'!
toogleShowInstance

	self showInstance: self showInstance not.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 13:37'!
toogleShowPackages

	self showPackages: self showPackages not.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/14/2011 13:02'!
update

	methodsTree ifNotNil: [:tree | tree update]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 16:12'!
window

	^ window! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 16:12'!
window: anObject

	window := anObject! !
